# OBJ - timestamped JSON objects.
#
# obj/core.py
#
# Copyright 2017,2018 B.H.J Thate
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy 
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights 
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
# copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice don't have to be included.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
# THE SOFTWARE.
#
# 08-02-2018 As the creator of this file, I disclaim all rights on this file. 
#
# Bart Thate
# Heerhugowaard
# The Netherlands

""" core module to stash runtime objects.. """

from obj.db import Db
from obj.loader import Loader
from obj.log import level
from obj.shell import parse_cli
from obj.thr import Launcher

#:
db = Db()

#:
fleet = []

#:
launcher = Launcher()

#:
loader = Loader()

## start function

def start(workdir=""):
    from obj import cfg
    cfg.update(parse_cli())
    cfg.workdir = workdir or cfg.workdir
    if cfg.banner:
        print("%s %s\n" % (cfg.name,  __version__))
    if cfg.level:
        level(cfg.level, form="plain")
    return cfg
